summaryrefslogtreecommitdiff
path: root/init.d/rc-enabled.in
diff options
context:
space:
mode:
authorRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
committerRoy Marples <roy@marples.name>2008-03-25 14:06:05 +0000
commit55eb3794fb4ad563102d5ab30c1d5337a599b2e5 (patch)
tree0d052faeb050c1e18ba56f6f6189bff3ffca28c9 /init.d/rc-enabled.in
parent08aff6ef44ac5dc438d916b53aa61385f6d299f3 (diff)
downloadopenrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.gz
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.bz2
openrc-55eb3794fb4ad563102d5ab30c1d5337a599b2e5.tar.xz
Rework our folder structure so that we don't have OS specific dirs, making it easier to share init and conf files per OS.
Diffstat (limited to 'init.d/rc-enabled.in')
-rw-r--r--init.d/rc-enabled.in54
1 files changed, 54 insertions, 0 deletions
diff --git a/init.d/rc-enabled.in b/init.d/rc-enabled.in
new file mode 100644
index 0000000..9801203
--- /dev/null
+++ b/init.d/rc-enabled.in
@@ -0,0 +1,54 @@
+#!@PREFIX@/sbin/runscript
+# Copyright 2007-2008 Roy Marples <roy@marples.name>
+# All rights reserved. Released under the 2-clause BSD license.
+
+depend()
+{
+ need localmount net
+ after *
+ before local
+ keyword noprefix
+}
+
+start()
+{
+ ebegin "Starting local rc services"
+ local svc= enabled= retval=0 service=
+ for svc in $(rcorder /etc/rc.d/* @PKG_PREFIX@/etc/rc.d/* 2>/dev/null); do
+ [ -x "$svc" ] || continue
+ service=${svc##*/}
+
+ # Skip these services
+ for s in cleartmp moused; do
+ [ "${s}" = "${service}" ] && continue 2
+ done
+
+ # If we have an init script for this service, continue
+ [ -x @SYSCONFDIR@/init.d/"${service}" ] && continue
+ [ -x @PKG_PREFIX@/@SYSCONFDIR@/init.d/"${service}" ] && continue
+ [ -x @LOCAL_PREFIX@/@SYSCONFDIR@/init.d/"${service}" ] && continue
+
+ # Ensure that the users rc.conf will start us - ignore the defaults
+ eval enabled=\$${svc##*/}_enable
+ yesno ${enabled} || yesno ${svc##*/} || continue
+
+ # Good to go!
+ "$svc" start && started="${started} ${svc}"
+ : $((retval += $?))
+ done
+ service_set_value started "${started}"
+ eend $retval "Some local rc services failed to start"
+ return 0
+}
+
+stop()
+{
+ ebegin "Stopping local rc services"
+ local svc= retval=0
+ for svc in $(rcorder $(service_get_value started) 2>/dev/null | sort -r); do
+ "${svc}" stop
+ : $((retval += $?))
+ done
+ eend $retval "Some local rc services failed to stop"
+ return 0
+}